import java.sql.*;

public class myJDBC 
{
	Connection con;

/* el String bd es el nombre de la base de datos a la cual nos vamos a conectar
   se la vamos a pasar como parametro desde el teclado con los argumentos de programa */
 	
	public myJDBC(String bd)
	{

// hacer el try es nesario por si no se tiene el driver en el directorio
		try
		{
// creo un objeto Driver

		     	new com.mysql.jdbc.Driver();

/* creo la conexion a la base de datos que esta en el servidor de nombre referenciado 
   por bd (en caso de no tener una bd se puede hacer bd="test", puesto que test es la 
   base de datos que viene por default en mysqladmin y me logeo sin usuario y sin 
   password */ 
	
      			con = DriverManager.getConnection("jdbc:mysql:///"+bd,"","");
		}
    		catch (Exception e)
		{
/* si hay problemas con la conexion las atrapa el catch 
   el caracter '\' es de escape, esto quiere decir que se imprimiran las comillas 
   explicitamente (da lo mismo... :P) */

      			System.out.println("no pude establecer la conexion a \""+bd+"\"");
    		}
  	
		try
		{
/* creamos un objeto de la clase Statement que le enviar los comandos SQL
   al motor de sql que este corriendo en el servidor. Los comandos se le entregan 
   a este objeto (en un gran string), el cual entrega los resultados de la query 
   en un objeto de la clase ResultSet */

     			Statement stmt = con.createStatement();

//hasta aqui es siempre lo mismo

//ahora viene lo distinto.

/* creo las tablas con el comando excecuteUpdate("");
   se debe tener en cuenta que si la tabla ya esta creada, tira excepcion */

			stmt.executeUpdate("CREATE TABLE jugador (codigo_equipo int, run varchar(8), nombre varchar(20), tipo varchar(10))");
// inserto jugadores			
			stmt.executeUpdate("insert into jugador (codigo_equipo,run,nombre,tipo) values (1,'12.345.678-9','cristhian moya','estrella')");
    			stmt.executeUpdate("insert into jugador (codigo_equipo,run,nombre,tipo) values (1,'5435-2','marcelo salas','delantero')");
			stmt.executeUpdate("insert into jugador (codigo_equipo,run,nombre,tipo) values (43,'6.434.324-0','donGraf','antidroga')");
			stmt.executeUpdate("insert into jugador (codigo_equipo,run,nombre,tipo) values (39,'13.213.125-k','pluto','arquero')");
			stmt.executeUpdate("insert into jugador (codigo_equipo,run,nombre,tipo) values (1,'12','pablo contreras','defensa')");

			stmt.executeUpdate("CREATE TABLE club (codigo int, nombre varchar(20), dt varchar(20))");
// inserto clubes	
			stmt.executeUpdate("insert into club (codigo,nombre,dt) values (1,'chile','don juve')");
    			stmt.executeUpdate("insert into club (codigo,nombre,dt) values (4,'river plate','ni idea')");
			stmt.executeUpdate("insert into club (codigo,nombre,dt) values (10,'colombia','xx')");
			stmt.executeUpdate("insert into club (codigo,nombre,dt) values (7,'desconocido','buen entrenador')");
			

			stmt.executeUpdate("CREATE TABLE fecha (codigo_local int, codigo_visita int, fecha varchar(10), resultado varchar(10),estadio varchar(10) )");
// inserto fechas	
			stmt.executeUpdate("insert into fecha (codigo_local,codigo_visita,fecha,resultado,estadio) values (1,43,'10/9/2003','2-1','nacional')");
    			stmt.executeUpdate("insert into fecha (codigo_local,codigo_visita,fecha,resultado,estadio) values (13,4,'4/11/2003',null,'monumental')");
    			stmt.executeUpdate("insert into fecha (codigo_local,codigo_visita,fecha,resultado,estadio) values (4,10,'1/3/2004',null,'nacional')");
    				
// la respuesta de la pregunta 1, con esta instruccion saco la tabla entera generada por el join (tabla de respuesta).

			ResultSet rs = stmt.executeQuery("SELECT jugador.nombre FROM jugador, club, fecha WHERE jugador.codigo_equipo = club.codigo AND club.nombre = 'chile' AND club.codigo = fecha.codigo_local AND fecha.fecha = '10/9/2003'");
				
/* voy a imprimir los titulos de las columnas notar que los indices comienzan 
   de 1 en las tablas de las bd y que n es la cantidad de columnas que tiene la tabla */

			ResultSetMetaData campos = rs.getMetaData();
			int n = campos.getColumnCount();
			for (int i=1; i<=n; i++) 
			{
				System.out.print(campos.getColumnLabel(i)+"");
			}
			System.out.println("\n---------");
			while (rs.next()) 
			{
/* En cada iteracion, el metodo next() entrega un registro completo de la tabla 
   por lo que hay que pedir los datos por campos */

				System.out.println(rs.getString("jugador.nombre"));
			}
System.out.println("---------");

//parte 2

//cambiar el entrenador del club 'desconocido' e imprimir las modificaciones.
		
		stmt.executeUpdate("UPDATE club SET dt = 'nelson acosta' WHERE club.nombre = 'desconocido'");
		ResultSet r= stmt.executeQuery("SELECT * FROM club WHERE club.nombre = 'desconocido'");
		while (r.next()) 
		{
			System.out.print("fue cambiado el dt del club ");
			System.out.println(r.getString("club.nombre")+" por "+r.getString("club.dt"));
		}
System.out.println("---------");

/* cambiar al 25/1/2005 la fecha de los partidos que se jueguen en el nacional con el equipo de codigo 10 de visita e 
   imprimir las modificaciones */
		
		stmt.executeUpdate("UPDATE fecha SET fecha = '25/1/2005' WHERE codigo_visita=10 AND estadio='nacional'");
		ResultSet r2= stmt.executeQuery("SELECT * FROM fecha WHERE codigo_visita=10 AND estadio='nacional'");
		while (r2.next()) 
		{
			System.out.print("fue cambiada la fecha del partido entre ");
			System.out.print(r2.getInt("fecha.codigo_local")+" y "+r2.getInt("fecha.codigo_visita")+" en el estadio "+r2.getString("fecha.estadio"));
		}
System.out.print("\n---------");	
//termino botando las tablas que creo el programa... 
		stmt.executeUpdate("drop table jugador,fecha,club");
		}
	   	catch (Exception ex)
		{
     			System.out.println("Problemas al consultar la base de datos \""+bd+"\"");  
  		}
	}


	
	public static void main (String argv[])
	{
		myJDBC nuevo=new myJDBC(argv[0]);
	}
}